from gtkmvc.controller import Controller
from gtk import main_quit
from birne_view import BirneSelectorView


class BirneController (Controller):
    """
    """

    def __init__(self, model):
        """Contructor. model will be accessible via the member 'self.model'.
        Registration is also performed."""
        Controller.__init__(self, model)
        self.model.registerObserver(self)
        return

    def registerView(self, view):
        Controller.registerView(self, view) # Calls the overloaded method

        # Connects the exiting signal:
        view.get_top_widget().connect("destroy", main_quit)
        view["quit"].connect("clicked", main_quit)
        #self.model.reset_current_settings()
        return

    # Signal (view -> self: hey, the user talks to us!)
    def on_addFile_clicked(self, button):
        print "on_addFile_clicked %s" % button
        selectorCtrl = BirneSelectorController(self.model)
        selector = BirneSelectorView(selectorCtrl)
        return

    def on_removeAllFiles_clicked(self, button):
        print "on_remove_allFiles_clicked %s" % button
        self.model.content = []
        return

    def on_burn_clicked(self, button):
        print "C: burn!"
        self.model.burn()
        return

    def on_mode_toggled(self, button):
        self.model.mode = button.get_name()
        return

    def on_speed_value_changed(self, button):
        self.model.speed = button.get_value()

    def on_rewritable_toggled(self, button):
        self.model.rewritable = button.get_active()
        return

    def on_burnFree_toggled(self, button):
        self.model.burnFree = button.get_active()
        return

    def on_simulate_toggled(self, button):
        self.model.simulate = button.get_active()
        return

###

    # Observables notifications (model -> self: hey, I am morphing!)
    def property_speed_change_notification(self, model, old, new):
        """  """
        print "C: model property speed changed: %s" % new
        return

    def property_rewritable_change_notification(self, model, old, new):
        """  """
        print "C: model property rewritable toggled: %s" % new
        return

    def property_burnFree_change_notification(self, model, old, new):
        """  """
        print "C: model property burnFree toggled: %s" % new
        return

    def property_simulate_change_notification(self, model, old, new):
        """  """
        print "C: model property simulate toggled: %s" % new
        return

    def property_content_change_notification(self, model, old, new):
        """  """
        print "C: model property content changed: %s" % new
        return

    def property_mode_change_notification(self, model, old, new):
        """  """
        print "C: model property mode changed: %s" % new
        if new == "copy":
            self.view["contentButtonBox"].foreach( lambda w: w.set_sensitive(False) )
            self.view["contentScrolledWindow"].set_sensitive(False)
        elif old == "copy":
            self.view["contentButtonBox"].foreach( lambda w: w.set_sensitive(True) )
            self.view["contentScrolledWindow"].set_sensitive(True)
        return


    pass # end of class

class BirneSelectorController(Controller):

    def __init__(self, model):
        """Contructor. model will be accessible via the member 'self.model'.
        Registration is also performed."""
        Controller.__init__(self, model)
        self.model.registerObserver(self)
        return

    def registerView(self, view):
        Controller.registerView(self, view) # Calls the overloaded method

        return

    def on_close_clicked(self, button):
        self.view.get_top_widget().destroy()
        return

    def on_select_clicked(self, button):
        self.model.content.append( self.view["mainWindow"].get_filenames() )
        return


    def on_rel_paths_toggled(self, button):
        print "C: rel_paths toggled: %s" % button.get_active()
        self.model.rel_paths = button.get_active()
        return

    def property_content_change_notification(self, model, old, new):
        """  """
        print "C: model property content changed: %s" % new
        return

    pass

# vim: expandtab ts=4
