from gtkmvc.model import Model

class BirneModel (Model):
    """ Model for Birne's main GUI. It contains properties for all the visible
    widgets and contains real world logic. The dirty work of a super model is
    done by the superclass Model."""

    __properties__ = {
        "mode"       : "copy",         # type of disc
        "speed"      : 4,              # burning speed
        "rewritable" : False,          # multi-session?
        "burnFree"   : True,           # extra buffers?
        "simulate"   : False,          # do not actually do anything?
        "content"    : [],              # contents of disc (files)
        "rel_paths"  : True            # whether use relative filenames for
                                       # disc layout
        }

    def __init__(self):
        Model.__init__(self)
        return

    def burn(self):
        """Executes the burning function appropriate for current mode."""
        method = getattr(self, "burn_%s" % self.mode, "burn_copy")
        method()
        return

    def burn_copy(self):
        print "burn copy"
        return

    def burn_audio(self):
        print "burn audio"
        return

    def burn_files(self):
        print "burn files"
        return

    def burn_image(self):
        print "burn image"
        return

#    def reset_current_settings(self):
#        """Re-sets the model to it's current state. This doesn't change the
#        model in any way but makes sure all observers know the model's current
#        state."""
#        for k, v in self.__properties__.items():
##            print "%s = %s" % (k, v)
#            k = v
#        print self.__properties__
#        return

    pass


# vim: expandtab ts=4
